#include <cstdio>
#include <iostream>
#include <cassert>
#include <vector>
#include <map>
#include <string>
#include <algorithm>
#include <sstream>
#include "testlib.h"

using namespace std;

int cur_test = -1;
const int MAXK = (int)1e5;


string itoa(int x) 
{
    stringstream ss;
    string s;
    ss << x;
    ss >> s;
    return s;
}

int atoi(string s) 
{
    stringstream ss;
    int x;
    ss << s;
    ss >> x;
    return x;
}



void write_test(int k, int x, int y) 
{
    startTest(cur_test++);
    cerr << cur_test << endl;
    cout << k << ' ' << x << ' ' << y << endl;
}

bool is_in_samples(int k, int x, int y)
{
    return (k == 2 && x == 0 && y == -1) ||
           (k == 5 && x == 1 && y == 2) ||
           (k == 1 && x == 2 && y == 2) ||
           (k == 10 && x == 0 && y == 3);
}

bool not_interesting(int k, int x, int y)
{
    return is_in_samples(k, x, y) ||
           (x == -1 && y == -1) ||
           (x + y > 3) || 
           (k % 2 == 0 && x == 1 && y == -1) ||
           (x == 3 && y == -1) ||
           (x == 0 && y == 0) ||
           (k % 2 == 0 && x == 1 && y == 2) ||
           (x == 1 && y == 0) || (x == 3 && y == 0);
}




int main(int argc, char * argv[]) 
{
    registerGen(argc, argv, 1);
    cur_test = atoi(argv[1]);
    
    //8 with k = 1
    write_test(1, 0, -1);
    write_test(1, 1, -1);
    write_test(1, -1, 1);
    write_test(1, 0, 1);
    write_test(1, 1, 0);
    write_test(1, 0, 3);
    write_test(1, 0, 0);
    write_test(1, 3, 3);
    
    //7 with k = 2
    write_test(2, 2, -1);
    write_test(2, -1, 0);
    write_test(2, -1, 2);
    write_test(2, 0, 2);
    write_test(2, 2, 0);
    write_test(2, -1, 1);
    write_test(2, 3, 3);



    int cnt = 15;
    
    
    for (int x = -1; x <= 3; x++)
        for (int y = -1; y <= 3; y++)
        {
            int k = rnd.next(4) * 2 + 3;
            if (!not_interesting(k, x, y))
                write_test(k, x, y), cnt++;
            k = rnd.next(4) * 2 + 4;
            if (!not_interesting(k, x, y))
                write_test(k, x, y), cnt++;
        }
    
    for (int k = 0; k < 4; k++)
    {
        write_test(k + 99, 2, -1);
        write_test(k + 99, -1, 1);
        write_test(k + 99, -1, 2);
        write_test(k + 99, -1, 3);
        write_test(k + 99, 0, 3);
        write_test(k + 99, 2, 1);
        cnt += 6;
    }
    
    for (int i = 100; i <= MAXK; i *= 10)
    {
        for (int j = 0; j < 3; j++)
        {
            int x = rnd.next(5) - 1;
            int y = rnd.next(5) - 1;
            int k = rnd.next(i / 2) + i / 2 + 1;
            while (not_interesting(k, x, y))
            {
                x = rnd.next(5) - 1;
                y = rnd.next(5) - 1;
                k = rnd.next(i / 2) + i / 2 + 1;
            }
            write_test(k, x, y);
            cnt++;
        }
    }
    for (int x = -1; x <= 3; x++)
        for (int y = -1; y <= 3; y++)
        {
            if (!not_interesting(MAXK, x, y))
                write_test(MAXK - 1, x, y), cnt++;
            if (!not_interesting(MAXK, x, y))
                write_test(MAXK, x, y), cnt++;
        }

    //for (int i = 0; i )
    //gen_rand(rnd.next(cur_max) + 1, 10);
    return 0;
}