#include "testlib.h"
#include <unordered_set>

using namespace std;

// 0 -- samples
// 1 -- n,k <= 5000
// 2 -- k <= 5000
// 3 -- full
const int MAX_N[] = {(int)1e9, 5000, (int)1e9, (int)1e9};
const int MAX_K[] = {200000, 5000, 5000, 200000};

int main(int argc, char * argv[])
{
    registerValidation(argc, argv);
	int group = atoi(validator.group().c_str());
    int n = inf.readInt(1, MAX_N[group], "n");
	inf.readSpace();
    int k = inf.readInt(1, min(2*n, MAX_K[group]), "k");
    inf.readEoln();

	unordered_set < int > occ[2];
    for (int i = 0; i < k; ++i)
    {
        int x = inf.readInt(1, n, "x_i");
		inf.readSpace();
        int y = inf.readInt(1, 2, "y_i");
		inf.readEoln();
		ensuref(!occ[y - 1].count(x), "all seats must be different");
		occ[y - 1].insert(x);
    }
    inf.readEof();

    return 0;
}
